<?php
namespace Teknisa\CRM\Factory;

use Doctrine\ORM\EntityManager;

class DashboardFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection       = $entityManager->getConnection();
    }
    
    public function getPivotedTermometro($nrorg, $opers, $colors){
        $select = "SELECT * FROM
                    (
                      SELECT COUNT(NRSEQOPORT) AS QUANTIDADE, 
                        DECODE(NMTERMOPORTUNI, NULL, 'SEMTERM', NMTERMOPORTUNI) AS TERMOMETRO, 
                        NMPRINCIPALPARC AS OPERADOR, OP.NRPARCNEGOCIO, OP.CDOPERADOR FROM
                        CRM_OPORTUNI OPORT
                        LEFT JOIN CRM_TERMOPORTUNI TERM
                        ON TERM.NRTERMOPORTUNI = OPORT.NRTERMOPORTUNI
                        AND TERM.NRORG = OPORT.NRORG
                        JOIN PARCNEGOCIO PARC
                        ON PARC.NRPARCNEGOCIO = OPORT.NRPARCRESP
                        JOIN OPERADOR OP
                        ON PARC.NRPARCNEGOCIO = OP.NRPARCNEGOCIO
                        AND PARC.NRORG = OP.NRORG
                        AND OPORT.NRPARCRESP IN($opers)
                        AND OPORT.NRORG = $nrorg 
                        AND OPORT.DTREALFECHA IS NULL
                        GROUP BY OPORT.NRTERMOPORTUNI, 
                        NMTERMOPORTUNI, DSCORHEXADECIMAL, 
                        NRPARCRESP, NMPRINCIPALPARC, op.nrparcnegocio, op.cdoperador
                    )
                    PIVOT 
                    (
                      MAX(QUANTIDADE)
                      FOR TERMOMETRO
                      IN ($colors)
                    )";
        
        
        $std = $this->connection->prepare($select);
        $std->executeQuery();
        return $std->fetchAll();
    }
    
    public function getOccurrences ($operator, $crmnrorgtrab, $nrorg) {

      $select = "SELECT SUM(QUANTIDADE) QUANTIDADE, STATUS, NRORDER 
      FROM (SELECT COUNT(NRSEQOPORT) AS QUANTIDADE, STATUS, NRORDER 
      FROM (SELECT OPORT.NRSEQOPORT, EVOL.CDOPERADORGEST, 'Ocorrências Pendentes' AS STATUS, 1 AS NRORDER 
      FROM CRM_OPORTUNI OPORT 
      JOIN EVOLCONT EVOL ON EVOL.NRCONTATO = OPORT.NRCONTATO AND EVOL.NRORG = OPORT.NRORG 
      WHERE OPORT.DTREALFECHA IS NULL 
      AND EVOL.NRSEQFASENEGO = '8' 
      AND EVOL.CDOPERADORGEST = $operator 
      AND OPORT.IDATIVO = 'S' 
      AND OPORT.CRM_NRORGTRAB = $crmnrorgtrab 
      AND OPORT.CRM_NRORGTRAB = $nrorg))
      GROUP BY STATUS, NRORDER 
      ORDER BY NRORDER";

      $std = $this->connection->prepare($select);
      $std->executeQuery();
      return $std->fetchAll();
      
    }   
}
